package com.sa.ibiz.demo.demoapp.controller.demo;

import java.io.InputStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.sql.Timestamp;
import javax.annotation.Resource;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.Data;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.node.ObjectNode;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import com.sa.ibiz.demo.ibizutil.domain.ActionResult;
import com.sa.ibiz.demo.demo.service.UserRoleResService;
import com.sa.ibiz.demo.ibizutil.domain.AutoCompleteItem;
import com.sa.ibiz.demo.demo.domain.UserRoleRes;
import com.sa.ibiz.demo.demo.service.dto.UserRoleResSearchFilter;
import com.sa.ibiz.demo.demoapp.controller.demo.vo.*;
import org.springframework.cglib.beans.BeanGenerator;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.util.StringUtils;
import java.io.IOException;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.validation.annotation.Validated;
import org.springframework.http.ResponseEntity;
import org.springframework.beans.factory.annotation.Autowired;
import com.sa.ibiz.demo.ibizutil.domain.RedirectResult;
import javax.validation.constraints.NotBlank;
import com.sa.ibiz.demo.ibizutil.domain.AutoCompleteItem;
import java.math.BigInteger;
import com.alibaba.fastjson.JSONObject;

@RestController
@RequestMapping("/demoapp/demo/userroleres")
public class UserRoleResController{



    @Autowired
	private UserRoleResService userroleresService;
	/**
	 * 获取服务对象
	*/
	protected UserRoleResService getService(){
		return this.userroleresService;
	}



	@PostMapping(value="main2editform/update")
	public ResponseEntity<UserRoleRes_EditForm_Main2> main2EditFormUpdate(@Validated @RequestBody UserRoleRes_EditForm_Main2 form){
            UserRoleRes entity =form.toUserRoleRes();
            getService().update(entity);
            form.fromUserRoleRes(entity);
            form.setSrfuf("1");
            return ResponseEntity.ok().body(form);
	}
	@GetMapping(value="main2editform/remove")
	public ResponseEntity<UserRoleRes_EditForm_Main2> main2EditFormRemove(@Validated @NotBlank(message = "srfkey不允许为空") @RequestParam("srfkey")String srfkey){
            UserRoleRes_EditForm_Main2 form=new UserRoleRes_EditForm_Main2();
            UserRoleRes entity = new UserRoleRes();
            entity.setUserroleresid(srfkey);
            getService().remove(entity);
            form.setSrfuf("0");
            form.fromUserRoleRes(entity);
            return ResponseEntity.ok().body(form);
	}
	@PostMapping(value="main2editform/getdraft")
	public ResponseEntity<UserRoleRes_EditForm_Main2> main2EditFormGetDraft(@RequestBody UserRoleRes_EditForm_Main2 form){
        if(!StringUtils.isEmpty(form.getSrfsourcekey()))
        {
            UserRoleRes sourceEntity =new UserRoleRes();
            sourceEntity.setUserroleresid(form.getSrfsourcekey());
            this.getService().get(sourceEntity);

			UserRoleRes targetEntity =new UserRoleRes();
			sourceEntity.copyTo(targetEntity);
			form.fromUserRoleRes(targetEntity,false);
            form.setSrfuf("0");
            return ResponseEntity.ok().body(form);
         }
            UserRoleRes entity =form.toUserRoleRes();
            getService().getDraft(entity);
            form.fromUserRoleRes(entity);
            form.setSrfuf("0");
            return ResponseEntity.ok().body(form);
	}
	@GetMapping(value="main2editform/get")
	public ResponseEntity<UserRoleRes_EditForm_Main2> main2EditFormGet(@Validated @NotBlank(message = "srfkey不允许为空") @RequestParam("srfkey")String srfkey){
            UserRoleRes_EditForm_Main2 form=new UserRoleRes_EditForm_Main2();
            UserRoleRes entity = new UserRoleRes();
            entity.setUserroleresid(srfkey);
            entity=getService().get(entity);
            form.setSrfuf("1");
            form.fromUserRoleRes(entity);
            return ResponseEntity.ok().body(form);
	}
	@PostMapping(value="main2editform/create")
	public ResponseEntity<UserRoleRes_EditForm_Main2> main2EditFormCreate(@Validated @RequestBody UserRoleRes_EditForm_Main2 form){
            UserRoleRes entity =form.toUserRoleRes();
            getService().create(entity);
            form.fromUserRoleRes(entity);
            form.setSrfuf("1");
            return ResponseEntity.ok().body(form);
	}
	@Autowired
	private com.sa.ibiz.demo.demo.service.UserRoleService userroleService;
	@PostMapping(value="main2editform/userrolename/ac")
	public ResponseEntity<List<AutoCompleteItem>> main2EditForm_userrolename_ac(@RequestBody UserRoleRes_EditForm_Main2 form){
		List<AutoCompleteItem> list =new ArrayList<>();
		com.sa.ibiz.demo.demo.service.dto.UserRoleSearchFilter searchFilter = new com.sa.ibiz.demo.demo.service.dto.UserRoleSearchFilter();
		UserRoleRes entity =form.toUserRoleRes();
		String queryField=entity.getUserrolename();
		searchFilter.getSelectCond().like("userrolename",queryField);
		Page<com.sa.ibiz.demo.demo.domain.UserRole> searchResult = userroleService.searchDefault(searchFilter);
		for(com.sa.ibiz.demo.demo.domain.UserRole entity2 :searchResult.getRecords()) {
			AutoCompleteItem acItem =new AutoCompleteItem();
			acItem.setValue(entity2.getUserroleid());
			acItem.setText(entity2.getUserrolename());
			acItem.setRealtext(entity2.getUserrolename());
			list.add(acItem);
			}
		return ResponseEntity.ok().body(list);
	}
	@Autowired
	private com.sa.ibiz.demo.demo.service.UniResService uniresService;
	@PostMapping(value="main2editform/uniresname/ac")
	public ResponseEntity<List<AutoCompleteItem>> main2EditForm_uniresname_ac(@RequestBody UserRoleRes_EditForm_Main2 form){
		List<AutoCompleteItem> list =new ArrayList<>();
		com.sa.ibiz.demo.demo.service.dto.UniResSearchFilter searchFilter = new com.sa.ibiz.demo.demo.service.dto.UniResSearchFilter();
		UserRoleRes entity =form.toUserRoleRes();
		String queryField=entity.getUniresname();
		searchFilter.getSelectCond().like("uniresname",queryField);
		Page<com.sa.ibiz.demo.demo.domain.UniRes> searchResult = uniresService.searchDefault(searchFilter);
		for(com.sa.ibiz.demo.demo.domain.UniRes entity2 :searchResult.getRecords()) {
			AutoCompleteItem acItem =new AutoCompleteItem();
			acItem.setValue(entity2.getUniresid());
			acItem.setText(entity2.getUniresname());
			acItem.setRealtext(entity2.getUniresname());
			list.add(acItem);
			}
		return ResponseEntity.ok().body(list);
	}
	@PostMapping(value="maingrid/update")
	public UserRoleRes mainGridUpdate(@Validated UserRoleRes mainItem){
		return mainItem;
	}
	@PostMapping(value="maingrid/remove")
	public ResponseEntity<UserRoleRes> mainGridRemove(@Validated @RequestBody Map args){
	    UserRoleRes entity =new UserRoleRes();
	    if ( !StringUtils.isEmpty(args.get("srfkeys"))) {
			String srfkeys=args.get("srfkeys").toString();
			String srfkeyArr[] =srfkeys.split(";");
			for(String srfkey : srfkeyArr)
			{
				if(!StringUtils.isEmpty(srfkey)){
				entity.setUserroleresid(srfkey);
				this.getService().remove(entity);
                }
            }
        }
		return ResponseEntity.ok().body(entity);
	}
	public UserRoleRes mainGridGet(String userroleresid){
		return null;
	}
	@PostMapping(value="maingrid/getdraft")
	public UserRoleRes mainGridGetDraft(@Validated UserRoleRes mainItem){
		return mainItem;
	}
	@PostMapping(value="maingrid/create")
	public UserRoleRes mainGridCreate(@Validated UserRoleRes mainItem){
		return mainItem;
	}
	@org.springframework.beans.factory.annotation.Value("${ibiz.filePath}")
    private String strFilePath;
	@Autowired
    private com.sa.ibiz.demo.ibizutil.service.IBZFILEService ibzfileService;
	/**
	 * [main]表格数据导出
	 * @param searchFilter
	 * @return
	 * @throws
	 * @throws
	 */
	@PostMapping(value="maingrid/exportdata/searchdefault")
	public ResponseEntity<Page<JSONObject>> maingridExportDataSearchDefault(@Validated @RequestBody UserRoleResSearchFilter searchFilter) throws IOException, jxl.write.WriteException {
		String fileid=com.baomidou.mybatisplus.core.toolkit.IdWorker.get32UUID();
		String localPath=ExportDataInit(fileid);//输出文件相对路径
		Page<UserRoleRes> searchResult = this.getService().searchDefault(searchFilter);//1.查询表格数据
		List<Map<String,Object>> datas=UserRoleRes_Grid_Main.pageToListDatas(searchResult);//2.将数据转换成list
		List<Map<String,String>> colnums=UserRoleRes_Grid_Main.getGridColumnModels();//3.获取表格列头
        java.io.File outputFile=com.sa.ibiz.demo.ibizutil.helper.DEDataExportHelper.output(strFilePath+localPath,colnums,datas);//4.生成导出文件
		com.sa.ibiz.demo.ibizutil.helper.DEDataExportHelper.saveFileData(outputFile,localPath,fileid,ibzfileService); //5.保存file表记录
		String strDownloadUrl =String.format("ibizutil/download/"+fileid);//6.回传文件路径给前台
        Page<JSONObject> resultObj=UserRoleRes_Grid_Main.getResultPage(searchResult,strDownloadUrl);//7.获取输出对象
			return ResponseEntity.ok().body(resultObj);
	}
	/**
	 * 表格数据导出
	 * @param fileid
	 * @return
	 */
	private String ExportDataInit(String fileid) {
		java.text.SimpleDateFormat dateFormat = new java.text.SimpleDateFormat("yyyyMMdd");
        String filepath=dateFormat.format(new java.util.Date())+ java.io.File.separator;
        java.text.SimpleDateFormat dateFormat2 = new java.text.SimpleDateFormat("yyyyMMddHHmmss");
		String strTempFileName = fileid+"-"+dateFormat2.format(new java.util.Date())+".xls";
		java.io.File file =new java.io.File(strFilePath+filepath);
		if(!file.exists())
           file.mkdirs();
		return filepath+strTempFileName;
	}
	@PostMapping(value="maingrid/searchdefault")
	public ResponseEntity<Page<UserRoleRes_Grid_Main>> mainGridSearchDefault(@Validated @RequestBody UserRoleResSearchFilter searchFilter){
			Page<UserRoleRes> searchResult = this.getService().searchDefault(searchFilter);
			Page<UserRoleRes_Grid_Main> searchResult_vo_data =UserRoleRes_Grid_Main.fromUserRoleRes(searchResult);
					return ResponseEntity.ok().body(searchResult_vo_data);
	}
	@PostMapping(value="defaultsearchform/load")
	public void defaultSearchFormLoad(){

	}
   	@PostMapping(value="defaultsearchform/loaddraft")
	public ResponseEntity<UserRoleRes_SearchForm_Default> defaultSearchFormLoadDraft(@Validated @RequestBody UserRoleRes_SearchForm_Default searchform){
 		 
			UserRoleResSearchFilter searchfilter =searchform.toUserRoleResSearchFilter();
			searchform.fromUserRoleResSearchFilter(searchfilter);
			return ResponseEntity.ok().body(searchform);
	} 
	@PostMapping(value="defaultsearchform/search")
	public void defaultSearchFormSearch(){
			 
	} 
 }